local job_id = Global.level_data and Global.level_data.level_id or ""
local difficulty = Global.game_settings and Global.game_settings.difficulty or "normal"

-- Localize globals
local math = math
local log = log
local Hooks = Hooks
local managers = managers

-- This saves _chk_relocate to a local variable and overwrites it and checks if the cop doesn't have an objective
-- or it's objective type isn't defend_area before executing the original function.
if RequiredScript == "lib/units/enemies/cop/logics/coplogicidle" then

local _chk_relocate = Hooks:GetFunction(CopLogicIdle, "_chk_relocate")
Hooks:OverrideFunction(CopLogicIdle, "_chk_relocate", function(data,...)
	if not data.objective or data.objective.type ~= "defend_area" then
		return _chk_relocate(data,...)
	end
end)

end

-- This is done so the game doesn't enable bagging the corpse, so we can switch between stealth and loud states
-- Not like bagging matters in a linear-map
if RequiredScript == "lib/units/enemies/cop/copbrain" then

local _chk_enable_bodybag_interaction = Hooks:GetFunction(CopBrain, "_chk_enable_bodybag_interaction")
Hooks:OverrideFunction(CopBrain, "_chk_enable_bodybag_interaction", function(self)
	if self:is_pager_started() then
		return
	end

	if not self._unit:character_damage():dead() then
		return
	end

	if not self._alarm_pager_has_run and self._unit:unit_data().has_alarm_pager then
		return
	end

	return true
end)

end

-- Randomizes SWAT arsenal
-- This is done by soft-overwriting default_weapon_name function and giving specific units different weapons depending on their access value or unit_name
if RequiredScript == "lib/units/enemies/cop/copbase" then

local LOADOUTS = {
	SWAT = {
		"mp5",
		"mp9",
		"m4"
	},
	COP = {
		"c45"
	}
}

Hooks:PostHook(CopBase, "default_weapon_name", "force_weapon_loadout", function(self, selection_name)
	local access = tweak_data.character[self._unit:base()._tweak_table].access

	if access == "swat" and self._default_weapon_id ~= "r870" and not string.find(self._unit:base()._tweak_table, "heavy_swat") then
		self._default_weapon_id = LOADOUTS.SWAT[math.random(1,#LOADOUTS.SWAT)]
	elseif self._unit:name():key() == Idstring("units/payday2/characters/ene_cop_2/ene_cop_2"):key() then
		-- Bronco cops just wield a glock now
		self._default_weapon_id = LOADOUTS.COP[math.random(1,#LOADOUTS.COP)]
	elseif access == "security" then
		self._default_weapon_id = "c45"
	end
end)

end

-- Setting up attention data
if RequiredScript == "lib/tweak_data/attentiontweakdata" then

Hooks:PostHook(AttentionTweakData, "init", "_upd_attention_data", function(self)
	for setting_name,setting in pairs(self.settings) do
		self.settings[setting_name].notice_requires_FOV = true
	end
end)

end

-- No dominating jokers
-- They all scripted-spawns anyway, why would you? >:(
if RequiredScript == "lib/units/enemies/cop/logics/coplogicbase" then

Hooks:OverrideFunction(CopLogicBase, "_evaluate_reason_to_surrender", function(data,my_data,aggressor_unit)
	return false
end)

end

-- Basically turn the game into a tactical-shooter
if RequiredScript == "lib/units/beings/player/playerdamage" then

-- BUG: This gived you god-mode lol
-- Idk what causes this exploit, and i'm not going to dig trough pd2's code just to figure it out
--[[

Hooks:OverrideFunction(PlayerDamage, "_on_enter_swansong_event", function() end)
Hooks:OverrideFunction(PlayerDamage, "_on_exit_swansong_event", function() end)
Hooks:OverrideFunction(PlayerDamage, "_update_regenerate_timer", function(t, dt) end)
Hooks:OverrideFunction(PlayerDamage, "is_friendly_fire", function(unit) return true end)

local _calc_health_damage = Hooks:GetFunction(PlayerDamage, "_calc_health_damage")
Hooks:OverrideFunction(PlayerDamage, "_calc_health_damage", function(self, attack_data)
	if self:get_real_armor() > 0 then
		return 0
	end

	return _calc_health_damage(self, attack_data)
end)
]]

end